---
layout: default
title: arm resource scans
nav_order: 1
---

# arm resource scans (auto generated)

|     | Id            | Type      | Entity                                                                       | Policy                                                                                                       | IaC   | Resource Link                                                                                                                                                                                                |
|-----|---------------|-----------|------------------------------------------------------------------------------|--------------------------------------------------------------------------------------------------------------|-------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
|   0 | CKV_AZURE_1   | resource  | Microsoft.Compute/virtualMachines                                            | Ensure Azure Instance does not use basic authentication(Use SSH Key Instead)                                 | arm   | [AzureInstancePassword.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AzureInstancePassword.py)                                                                           |
|   1 | CKV_AZURE_2   | resource  | Microsoft.Compute/disks                                                      | Ensure Azure managed disk have encryption enabled                                                            | arm   | [AzureManagedDiscEncryption.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AzureManagedDiscEncryption.py)                                                                 |
|   2 | CKV_AZURE_3   | resource  | Microsoft.Storage/storageAccounts                                            | Ensure that 'supportsHttpsTrafficOnly' is set to 'true'                                                      | arm   | [StorageAccountsTransportEncryption.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/StorageAccountsTransportEncryption.py)                                                 |
|   3 | CKV_AZURE_4   | resource  | Microsoft.ContainerService/managedClusters                                   | Ensure AKS logging to Azure Monitoring is Configured                                                         | arm   | [AKSLoggingEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AKSLoggingEnabled.py)                                                                                   |
|   4 | CKV_AZURE_5   | resource  | Microsoft.ContainerService/managedClusters                                   | Ensure RBAC is enabled on AKS clusters                                                                       | arm   | [AKSRbacEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AKSRbacEnabled.py)                                                                                         |
|   5 | CKV_AZURE_6   | resource  | Microsoft.ContainerService/managedClusters                                   | Ensure AKS has an API Server Authorized IP Ranges enabled                                                    | arm   | [AKSApiServerAuthorizedIpRanges.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AKSApiServerAuthorizedIpRanges.py)                                                         |
|   6 | CKV_AZURE_7   | resource  | Microsoft.ContainerService/managedClusters                                   | Ensure AKS cluster has Network Policy configured                                                             | arm   | [AKSNetworkPolicy.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AKSNetworkPolicy.py)                                                                                     |
|   7 | CKV_AZURE_8   | resource  | Microsoft.ContainerService/managedClusters                                   | Ensure Kubernetes Dashboard is disabled                                                                      | arm   | [AKSDashboardDisabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AKSDashboardDisabled.py)                                                                             |
|   8 | CKV_AZURE_9   | resource  | Microsoft.Network/networkSecurityGroups                                      | Ensure that RDP access is restricted from the internet                                                       | arm   | [NSGRuleRDPAccessRestricted.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/NSGRuleRDPAccessRestricted.py)                                                                 |
|   9 | CKV_AZURE_9   | resource  | Microsoft.Network/networkSecurityGroups/securityRules                        | Ensure that RDP access is restricted from the internet                                                       | arm   | [NSGRuleRDPAccessRestricted.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/NSGRuleRDPAccessRestricted.py)                                                                 |
|  10 | CKV_AZURE_10  | resource  | Microsoft.Network/networkSecurityGroups                                      | Ensure that SSH access is restricted from the internet                                                       | arm   | [NSGRuleSSHAccessRestricted.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/NSGRuleSSHAccessRestricted.py)                                                                 |
|  11 | CKV_AZURE_10  | resource  | Microsoft.Network/networkSecurityGroups/securityRules                        | Ensure that SSH access is restricted from the internet                                                       | arm   | [NSGRuleSSHAccessRestricted.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/NSGRuleSSHAccessRestricted.py)                                                                 |
|  12 | CKV_AZURE_11  | resource  | Microsoft.Sql/servers                                                        | Ensure no SQL Databases allow ingress from 0.0.0.0/0 (ANY IP)                                                | arm   | [SQLServerNoPublicAccess.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SQLServerNoPublicAccess.py)                                                                       |
|  13 | CKV_AZURE_12  | resource  | Microsoft.Network/networkWatchers/FlowLogs                                   | Ensure that Network Security Group Flow Log retention period is 'greater than 90 days'                       | arm   | [NetworkWatcherFlowLogPeriod.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/NetworkWatcherFlowLogPeriod.py)                                                               |
|  14 | CKV_AZURE_12  | resource  | Microsoft.Network/networkWatchers/FlowLogs/                                  | Ensure that Network Security Group Flow Log retention period is 'greater than 90 days'                       | arm   | [NetworkWatcherFlowLogPeriod.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/NetworkWatcherFlowLogPeriod.py)                                                               |
|  15 | CKV_AZURE_12  | resource  | Microsoft.Network/networkWatchers/flowLogs                                   | Ensure that Network Security Group Flow Log retention period is 'greater than 90 days'                       | arm   | [NetworkWatcherFlowLogPeriod.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/NetworkWatcherFlowLogPeriod.py)                                                               |
|  16 | CKV_AZURE_12  | resource  | Microsoft.Network/networkWatchers/flowLogs/                                  | Ensure that Network Security Group Flow Log retention period is 'greater than 90 days'                       | arm   | [NetworkWatcherFlowLogPeriod.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/NetworkWatcherFlowLogPeriod.py)                                                               |
|  17 | CKV_AZURE_13  | resource  | Microsoft.Web/sites/config                                                   | Ensure App Service Authentication is set on Azure App Service                                                | arm   | [AppServiceAuthentication.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceAuthentication.py)                                                                     |
|  18 | CKV_AZURE_13  | resource  | config                                                                       | Ensure App Service Authentication is set on Azure App Service                                                | arm   | [AppServiceAuthentication.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceAuthentication.py)                                                                     |
|  19 | CKV_AZURE_14  | resource  | Microsoft.Web/sites                                                          | Ensure web app redirects all HTTP traffic to HTTPS in Azure App Service                                      | arm   | [AppServiceHTTPSOnly.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceHTTPSOnly.py)                                                                               |
|  20 | CKV_AZURE_15  | resource  | Microsoft.Web/sites                                                          | Ensure web app is using the latest version of TLS encryption                                                 | arm   | [AppServiceMinTLSVersion.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceMinTLSVersion.py)                                                                       |
|  21 | CKV_AZURE_16  | resource  | Microsoft.Web/sites                                                          | Ensure that Register with Azure Active Directory is enabled on App Service                                   | arm   | [AppServiceIdentity.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceIdentity.py)                                                                                 |
|  22 | CKV_AZURE_17  | resource  | Microsoft.Web/sites                                                          | Ensure the web app has 'Client Certificates (Incoming client certificates)' set                              | arm   | [AppServiceClientCertificate.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceClientCertificate.py)                                                               |
|  23 | CKV_AZURE_18  | resource  | Microsoft.Web/sites                                                          | Ensure that 'HTTP Version' is the latest if used to run the web app                                          | arm   | [AppServiceHttps20Enabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceHttps20Enabled.py)                                                                     |
|  24 | CKV_AZURE_19  | resource  | Microsoft.Security/pricings                                                  | Ensure that standard pricing tier is selected                                                                | arm   | [SecurityCenterStandardPricing.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SecurityCenterStandardPricing.py)                                                           |
|  25 | CKV_AZURE_20  | resource  | Microsoft.Security/securityContacts                                          | Ensure that security contact 'Phone number' is set                                                           | arm   | [SecurityCenterContactPhone.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SecurityCenterContactPhone.py)                                                                 |
|  26 | CKV_AZURE_21  | resource  | Microsoft.Security/securityContacts                                          | Ensure that 'Send email notification for high severity alerts' is set to 'On'                                | arm   | [SecurityCenterContactEmailAlert.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SecurityCenterContactEmailAlert.py)                                                       |
|  27 | CKV_AZURE_22  | resource  | Microsoft.Security/securityContacts                                          | Ensure that 'Send email notification for high severity alerts' is set to 'On'                                | arm   | [SecurityCenterContactEmailAlertAdmins.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SecurityCenterContactEmailAlertAdmins.py)                                           |
|  28 | CKV_AZURE_23  | resource  | Microsoft.Sql/servers                                                        | Ensure that 'Auditing' is set to 'Enabled' for SQL servers                                                   | arm   | [SQLServerAuditingEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SQLServerAuditingEnabled.py)                                                                     |
|  29 | CKV_AZURE_23  | resource  | Microsoft.Sql/servers/databases                                              | Ensure that 'Auditing' is set to 'Enabled' for SQL servers                                                   | arm   | [SQLServerAuditingEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SQLServerAuditingEnabled.py)                                                                     |
|  30 | CKV_AZURE_24  | resource  | Microsoft.Sql/servers                                                        | Ensure that 'Auditing' Retention is 'greater than 90 days' for SQL servers                                   | arm   | [SQLServerAuditingRetention90Days.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SQLServerAuditingRetention90Days.py)                                                     |
|  31 | CKV_AZURE_25  | resource  | Microsoft.Sql/servers/databases                                              | Ensure that 'Threat Detection types' is set to 'All'                                                         | arm   | [SQLServerThreatDetectionTypes.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SQLServerThreatDetectionTypes.py)                                                           |
|  32 | CKV_AZURE_26  | resource  | Microsoft.Sql/servers/databases                                              | Ensure that 'Send Alerts To' is enabled for MSSQL servers                                                    | arm   | [SQLServerEmailAlertsEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SQLServerEmailAlertsEnabled.py)                                                               |
|  33 | CKV_AZURE_27  | resource  | Microsoft.Sql/servers/databases                                              | Ensure that 'Email service and co-administrators' is 'Enabled' for MSSQL servers                             | arm   | [SQLServerEmailAlertsToAdminsEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SQLServerEmailAlertsToAdminsEnabled.py)                                               |
|  34 | CKV_AZURE_28  | resource  | Microsoft.DBforMySQL/servers                                                 | Ensure 'Enforce SSL connection' is set to 'ENABLED' for MySQL Database Server                                | arm   | [MySQLServerSSLEnforcementEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/MySQLServerSSLEnforcementEnabled.py)                                                     |
|  35 | CKV_AZURE_29  | resource  | Microsoft.DBforPostgreSQL/servers                                            | Ensure 'Enforce SSL connection' is set to 'ENABLED' for PostgreSQL Database Server                           | arm   | [PostgreSQLServerSSLEnforcementEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/PostgreSQLServerSSLEnforcementEnabled.py)                                           |
|  36 | CKV_AZURE_30  | resource  | Microsoft.DBforPostgreSQL/servers/configurations                             | Ensure server parameter 'log_checkpoints' is set to 'ON' for PostgreSQL Database Server                      | arm   | [PostgreSQLServerLogCheckpointsEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/PostgreSQLServerLogCheckpointsEnabled.py)                                           |
|  37 | CKV_AZURE_30  | resource  | configurations                                                               | Ensure server parameter 'log_checkpoints' is set to 'ON' for PostgreSQL Database Server                      | arm   | [PostgreSQLServerLogCheckpointsEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/PostgreSQLServerLogCheckpointsEnabled.py)                                           |
|  38 | CKV_AZURE_31  | resource  | Microsoft.DBforPostgreSQL/servers/configurations                             | Ensure configuration 'log_connections' is set to 'ON' for PostgreSQL Database Server                         | arm   | [PostgreSQLServerLogConnectionsEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/PostgreSQLServerLogConnectionsEnabled.py)                                           |
|  39 | CKV_AZURE_31  | resource  | configurations                                                               | Ensure configuration 'log_connections' is set to 'ON' for PostgreSQL Database Server                         | arm   | [PostgreSQLServerLogConnectionsEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/PostgreSQLServerLogConnectionsEnabled.py)                                           |
|  40 | CKV_AZURE_32  | resource  | Microsoft.DBforPostgreSQL/servers/configurations                             | Ensure server parameter 'connection_throttling' is set to 'ON' for PostgreSQL Database Server                | arm   | [PostgreSQLServerConnectionThrottlingEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/PostgreSQLServerConnectionThrottlingEnabled.py)                               |
|  41 | CKV_AZURE_32  | resource  | configurations                                                               | Ensure server parameter 'connection_throttling' is set to 'ON' for PostgreSQL Database Server                | arm   | [PostgreSQLServerConnectionThrottlingEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/PostgreSQLServerConnectionThrottlingEnabled.py)                               |
|  42 | CKV_AZURE_33  | resource  | Microsoft.Storage/storageAccounts/queueServices/providers/diagnosticsettings | Ensure Storage logging is enabled for Queue service for read, write and delete requests                      | arm   | [StorageAccountLoggingQueueServiceEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/StorageAccountLoggingQueueServiceEnabled.py)                                     |
|  43 | CKV_AZURE_34  | resource  | Microsoft.Storage/storageAccounts/blobServices/containers                    | Ensure that 'Public access level' is set to Private for blob containers                                      | arm   | [StorageBlobServiceContainerPrivateAccess.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/StorageBlobServiceContainerPrivateAccess.py)                                     |
|  44 | CKV_AZURE_34  | resource  | blobServices/containers                                                      | Ensure that 'Public access level' is set to Private for blob containers                                      | arm   | [StorageBlobServiceContainerPrivateAccess.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/StorageBlobServiceContainerPrivateAccess.py)                                     |
|  45 | CKV_AZURE_34  | resource  | containers                                                                   | Ensure that 'Public access level' is set to Private for blob containers                                      | arm   | [StorageBlobServiceContainerPrivateAccess.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/StorageBlobServiceContainerPrivateAccess.py)                                     |
|  46 | CKV_AZURE_35  | resource  | Microsoft.Storage/storageAccounts                                            | Ensure default network access rule for Storage Accounts is set to deny                                       | arm   | [StorageAccountDefaultNetworkAccessDeny.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/StorageAccountDefaultNetworkAccessDeny.py)                                         |
|  47 | CKV_AZURE_36  | resource  | Microsoft.Storage/storageAccounts                                            | Ensure 'Trusted Microsoft Services' is enabled for Storage Account access                                    | arm   | [StorageAccountAzureServicesAccessEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/StorageAccountAzureServicesAccessEnabled.py)                                     |
|  48 | CKV_AZURE_37  | resource  | Microsoft.Insights/logprofiles                                               | Ensure that Activity Log Retention is set 365 days or greater                                                | arm   | [MonitorLogProfileRetentionDays.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/MonitorLogProfileRetentionDays.py)                                                         |
|  49 | CKV_AZURE_38  | resource  | Microsoft.Insights/logprofiles                                               | Ensure audit profile captures all the activities                                                             | arm   | [MonitorLogProfileCategories.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/MonitorLogProfileCategories.py)                                                               |
|  50 | CKV_AZURE_39  | resource  | Microsoft.Authorization/roleDefinitions                                      | Ensure that no custom subscription owner roles are created                                                   | arm   | [CustomRoleDefinitionSubscriptionOwner.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/CustomRoleDefinitionSubscriptionOwner.py)                                           |
|  51 | CKV_AZURE_40  | resource  | Microsoft.KeyVault/vaults/keys                                               | Ensure that the expiration date is set on all keys                                                           | arm   | [KeyExpirationDate.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/KeyExpirationDate.py)                                                                                   |
|  52 | CKV_AZURE_41  | resource  | Microsoft.KeyVault/vaults/secrets                                            | Ensure that the expiration date is set on all secrets                                                        | arm   | [SecretExpirationDate.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SecretExpirationDate.py)                                                                             |
|  53 | CKV_AZURE_42  | resource  | Microsoft.KeyVault/vaults                                                    | Ensure the key vault is recoverable                                                                          | arm   | [KeyvaultRecoveryEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/KeyvaultRecoveryEnabled.py)                                                                       |
|  54 | CKV_AZURE_44  | resource  | Microsoft.Storage/storageAccounts                                            | Ensure Storage Account is using the latest version of TLS encryption                                         | arm   | [StorageAccountMinimumTlsVersion.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/StorageAccountMinimumTlsVersion.py)                                                       |
|  55 | CKV_AZURE_47  | resource  | Microsoft.DBforMariaDB/servers                                               | Ensure 'Enforce SSL connection' is set to 'ENABLED' for MariaDB servers                                      | arm   | [MariaDBSSLEnforcementEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/MariaDBSSLEnforcementEnabled.py)                                                             |
|  56 | CKV_AZURE_48  | resource  | Microsoft.DBforMariaDB/servers                                               | Ensure 'public network access enabled' is set to 'False' for MariaDB servers                                 | arm   | [MariaDBPublicAccessDisabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/MariaDBPublicAccessDisabled.py)                                                               |
|  57 | CKV_AZURE_49  | resource  | Microsoft.Compute/virtualMachineScaleSets                                    | Ensure Azure linux scale set does not use basic authentication(Use SSH Key Instead)                          | arm   | [AzureScaleSetPassword.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AzureScaleSetPassword.py)                                                                           |
|  58 | CKV_AZURE_50  | resource  | Microsoft.Compute/virtualMachines                                            | Ensure Virtual Machine Extensions are not Installed                                                          | arm   | [AzureInstanceExtensions.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AzureInstanceExtensions.py)                                                                       |
|  59 | CKV_AZURE_52  | resource  | Microsoft.Sql/servers                                                        | Ensure MSSQL is using the latest version of TLS encryption                                                   | arm   | [MSSQLServerMinTLSVersion.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/MSSQLServerMinTLSVersion.py)                                                                     |
|  60 | CKV_AZURE_53  | resource  | Microsoft.DBforMySQL/servers                                                 | Ensure 'public network access enabled' is set to 'False' for mySQL servers                                   | arm   | [MySQLPublicAccessDisabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/MySQLPublicAccessDisabled.py)                                                                   |
|  61 | CKV_AZURE_54  | resource  | Microsoft.DBforMySQL/servers                                                 | Ensure MySQL is using the latest version of TLS encryption                                                   | arm   | [MySQLServerMinTLSVersion.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/MySQLServerMinTLSVersion.py)                                                                     |
|  62 | CKV_AZURE_56  | resource  | Microsoft.Web/sites/config                                                   | Ensure that function apps enables Authentication                                                             | arm   | [FunctionAppsEnableAuthentication.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/FunctionAppsEnableAuthentication.py)                                                     |
|  63 | CKV_AZURE_57  | resource  | Microsoft.Web/sites                                                          | Ensure that CORS disallows every resource to access app services                                             | arm   | [AppServiceDisallowCORS.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceDisallowCORS.py)                                                                         |
|  64 | CKV_AZURE_58  | resource  | Microsoft.Synapse/workspaces                                                 | Ensure that Azure Synapse workspaces enables managed virtual networks                                        | arm   | [SynapseWorkspaceEnablesManagedVirtualNetworks.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SynapseWorkspaceEnablesManagedVirtualNetworks.py)                           |
|  65 | CKV_AZURE_59  | resource  | Microsoft.Storage/storageAccounts                                            | Ensure that Storage accounts disallow public access                                                          | arm   | [StorageAccountDisablePublicAccess.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/StorageAccountDisablePublicAccess.py)                                                   |
|  66 | CKV_AZURE_62  | resource  | Microsoft.Web/sites                                                          | Ensure function apps are not accessible from all regions                                                     | arm   | [FunctionAppDisallowCORS.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/FunctionAppDisallowCORS.py)                                                                       |
|  67 | CKV_AZURE_63  | resource  | Microsoft.Web/sites/config                                                   | Ensure that App service enables HTTP logging                                                                 | arm   | [AppServiceHttpLoggingEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceHttpLoggingEnabled.py)                                                             |
|  68 | CKV_AZURE_64  | resource  | Microsoft.StorageSync/storageSyncServices                                    | Ensure that Azure File Sync disables public network access                                                   | arm   | [StorageSyncPublicAccessDisabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/StorageSyncPublicAccessDisabled.py)                                                       |
|  69 | CKV_AZURE_65  | resource  | Microsoft.Web/sites/config                                                   | Ensure that App service enables detailed error messages                                                      | arm   | [AppServiceDetailedErrorMessagesEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceDetailedErrorMessagesEnabled.py)                                         |
|  70 | CKV_AZURE_66  | resource  | Microsoft.Web/sites/config                                                   | Ensure that App service enables failed request tracing                                                       | arm   | [AppServiceEnableFailedRequest.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceEnableFailedRequest.py)                                                           |
|  71 | CKV_AZURE_67  | resource  | Microsoft.Web/sites                                                          | Ensure that 'HTTP Version' is the latest, if used to run the Function app                                    | arm   | [FunctionAppHttpVersionLatest.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/FunctionAppHttpVersionLatest.py)                                                             |
|  72 | CKV_AZURE_67  | resource  | Microsoft.Web/sites/slots                                                    | Ensure that 'HTTP Version' is the latest, if used to run the Function app                                    | arm   | [FunctionAppHttpVersionLatest.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/FunctionAppHttpVersionLatest.py)                                                             |
|  73 | CKV_AZURE_68  | resource  | Microsoft.DBforPostgreSQL/servers                                            | Ensure that PostgreSQL server disables public network access                                                 | arm   | [PostgreSQLServerPublicAccessDisabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/PostgreSQLServerPublicAccessDisabled.py)                                             |
|  74 | CKV_AZURE_71  | resource  | Microsoft.Web/sites                                                          | Ensure that Managed identity provider is enabled for web apps                                                | arm   | [AppServiceIdentityProviderEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceIdentityProviderEnabled.py)                                                   |
|  75 | CKV_AZURE_72  | resource  | Microsoft.Web/sites                                                          | Ensure that remote debugging is not enabled for app services                                                 | arm   | [AppServiceRemoteDebuggingNotEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceRemoteDebuggingNotEnabled.py)                                               |
|  76 | CKV_AZURE_73  | resource  | Microsoft.Automation/automationAccounts/variables                            | Ensure that Automation account variables are encrypted                                                       | arm   | [AutomationEncrypted.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AutomationEncrypted.py)                                                                               |
|  77 | CKV_AZURE_74  | resource  | Microsoft.Kusto/clusters                                                     | Ensure that Azure Data Explorer (Kusto) uses disk encryption                                                 | arm   | [DataExplorerUsesDiskEncryption.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/DataExplorerUsesDiskEncryption.py)                                                         |
|  78 | CKV_AZURE_76  | resource  | Microsoft.Batch/batchAccounts                                                | Ensure that Azure Batch account uses key vault to encrypt data                                               | arm   | [AzureBatchAccountUsesKeyVaultEncryption.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AzureBatchAccountUsesKeyVaultEncryption.py)                                       |
|  79 | CKV_AZURE_78  | resource  | Microsoft.Web/sites                                                          | Ensure FTP deployments are disabled                                                                          | arm   | [AppServiceFTPSState.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceFTPSState.py)                                                                               |
|  80 | CKV_AZURE_80  | resource  | Microsoft.Web/sites/config                                                   | Ensure that 'Net Framework' version is the latest, if used as a part of the web app                          | arm   | [AppServiceDotnetFrameworkVersion.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceDotnetFrameworkVersion.py)                                                     |
|  81 | CKV_AZURE_82  | resource  | Microsoft.Web/sites                                                          | Ensure that 'Python version' is the latest, if used to run the web app                                       | arm   | [AppServicePythonVersion.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServicePythonVersion.py)                                                                       |
|  82 | CKV_AZURE_83  | resource  | Microsoft.Web/sites                                                          | Ensure that 'Java version' is the latest, if used to run the web app                                         | arm   | [AppServiceJavaVersion.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceJavaVersion.py)                                                                           |
|  83 | CKV_AZURE_84  | resource  | Microsoft.Security/pricings                                                  | Ensure that Azure Defender is set to On for Storage                                                          | arm   | [AzureDefenderOnStorage.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AzureDefenderOnStorage.py)                                                                         |
|  84 | CKV_AZURE_88  | resource  | Microsoft.Web/sites/config                                                   | Ensure that app services use Azure Files                                                                     | arm   | [AppServiceUsedAzureFiles.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppServiceUsedAzureFiles.py)                                                                     |
|  85 | CKV_AZURE_89  | resource  | Microsoft.Cache/redis                                                        | Ensure that Azure Cache for Redis disables public network access                                             | arm   | [RedisCachePublicNetworkAccessEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/RedisCachePublicNetworkAccessEnabled.py)                                             |
|  86 | CKV_AZURE_93  | resource  | Microsoft.Compute/disks                                                      | Ensure that managed disks use a specific set of disk encryption sets for the customer-managed key encryption | arm   | [AzureManagedDiskEncryptionSet.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AzureManagedDiskEncryptionSet.py)                                                           |
|  87 | CKV_AZURE_94  | resource  | Microsoft.DBforMySQL/flexibleServers                                         | Ensure that My SQL server enables geo-redundant backups                                                      | arm   | [MySQLGeoBackupEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/MySQLGeoBackupEnabled.py)                                                                           |
|  88 | CKV_AZURE_95  | resource  | Microsoft.Compute/virtualMachineScaleSets                                    | Ensure that automatic OS image patching is enabled for Virtual Machine Scale Sets                            | arm   | [VMScaleSetsAutoOSImagePatchingEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/VMScaleSetsAutoOSImagePatchingEnabled.py)                                           |
|  89 | CKV_AZURE_96  | resource  | Microsoft.DBforMySQL/flexibleServers                                         | Ensure that MySQL server enables infrastructure encryption                                                   | arm   | [MySQLEncryptionEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/MySQLEncryptionEnabled.py)                                                                         |
|  90 | CKV_AZURE_97  | resource  | Microsoft.Compute/virtualMachineScaleSets                                    | Ensure that Virtual machine scale sets have encryption at host enabled                                       | arm   | [VMEncryptionAtHostEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/VMEncryptionAtHostEnabled.py)                                                                   |
|  91 | CKV_AZURE_97  | resource  | Microsoft.Compute/virtualMachines                                            | Ensure that Virtual machine scale sets have encryption at host enabled                                       | arm   | [VMEncryptionAtHostEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/VMEncryptionAtHostEnabled.py)                                                                   |
|  92 | CKV_AZURE_100 | resource  | Microsoft.DocumentDb/databaseAccounts                                        | Ensure that Cosmos DB accounts have customer-managed keys to encrypt data at rest                            | arm   | [CosmosDBHaveCMK.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/CosmosDBHaveCMK.py)                                                                                       |
|  93 | CKV_AZURE_101 | resource  | Microsoft.DocumentDB/databaseAccounts                                        | Ensure that Azure Cosmos DB disables public network access                                                   | arm   | [CosmosDBDisablesPublicNetwork.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/CosmosDBDisablesPublicNetwork.py)                                                           |
|  94 | CKV_AZURE_103 | resource  | Microsoft.DataFactory/factories                                              | Ensure that Azure Data Factory uses Git repository for source control                                        | arm   | [DataFactoryUsesGitRepository.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/DataFactoryUsesGitRepository.py)                                                             |
|  95 | CKV_AZURE_107 | resource  | Microsoft.ApiManagement/service                                              | Ensure that API management services use virtual networks                                                     | arm   | [APIServicesUseVirtualNetwork.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/APIServicesUseVirtualNetwork.py)                                                             |
|  96 | CKV_AZURE_109 | resource  | Microsoft.KeyVault/vaults                                                    | Ensure that key vault allows firewall rules settings                                                         | arm   | [KeyVaultEnablesFirewallRulesSettings.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/KeyVaultEnablesFirewallRulesSettings.py)                                             |
|  97 | CKV_AZURE_111 | resource  | Microsoft.KeyVault/vaults                                                    | Ensure that key vault enables soft delete                                                                    | arm   | [KeyVaultEnablesSoftDelete.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/KeyVaultEnablesSoftDelete.py)                                                                   |
|  98 | CKV_AZURE_112 | resource  | Microsoft.KeyVault/vaults/keys                                               | Ensure that key vault key is backed by HSM                                                                   | arm   | [KeyBackedByHSM.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/KeyBackedByHSM.py)                                                                                         |
|  99 | CKV_AZURE_113 | resource  | Microsoft.Sql/servers                                                        | Ensure that SQL server disables public network access                                                        | arm   | [SQLServerHasPublicAccessDisabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SQLServerHasPublicAccessDisabled.py)                                                     |
| 100 | CKV_AZURE_114 | resource  | Microsoft.KeyVault/vaults/secrets                                            | Ensure that key vault secrets have "content_type" set                                                        | arm   | [SecretContentType.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SecretContentType.py)                                                                                   |
| 101 | CKV_AZURE_121 | resource  | Microsoft.Network/frontDoors                                                 | Ensure that Azure Front Door enables WAF                                                                     | arm   | [AzureFrontDoorEnablesWAF.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AzureFrontDoorEnablesWAF.py)                                                                     |
| 102 | CKV_AZURE_123 | resource  | Microsoft.Network/FrontDoorWebApplicationFirewallPolicies                    | Ensure that Azure Front Door uses WAF in "Detection" or "Prevention" modes                                   | arm   | [FrontdoorUseWAFMode.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/FrontdoorUseWAFMode.py)                                                                               |
| 103 | CKV_AZURE_125 | resource  | Microsoft.ServiceFabric/clusters                                             | Ensures that Service Fabric use three levels of protection available                                         | arm   | [AzureServiceFabricClusterProtectionLevel.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AzureServiceFabricClusterProtectionLevel.py)                                     |
| 104 | CKV_AZURE_130 | resource  | Microsoft.DBforPostgreSQL/servers                                            | Ensure that PostgreSQL server enables infrastructure encryption                                              | arm   | [PostgreSQLEncryptionEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/PostgreSQLEncryptionEnabled.py)                                                               |
| 105 | CKV_AZURE_131 | parameter | secureString                                                                 | SecureString parameter should not have hardcoded default values                                              | arm   | [SecureStringParameterNoHardcodedValue.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/parameter/SecureStringParameterNoHardcodedValue.py)                                          |
| 106 | CKV_AZURE_132 | resource  | Microsoft.DocumentDB/databaseAccounts                                        | Ensure cosmosdb does not allow privileged escalation by restricting management plane changes                 | arm   | [CosmosDBDisableAccessKeyWrite.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/CosmosDBDisableAccessKeyWrite.py)                                                           |
| 107 | CKV_AZURE_134 | resource  | Microsoft.CognitiveServices/accounts                                         | Ensure that Cognitive Services accounts disable public network access                                        | arm   | [CognitiveServicesDisablesPublicNetwork.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/CognitiveServicesDisablesPublicNetwork.py)                                         |
| 108 | CKV_AZURE_135 | resource  | Microsoft.Network/ApplicationGatewayWebApplicationFirewallPolicies           | Ensure Application Gateway WAF prevents message lookup in Log4j2. See CVE-2021-44228 aka log4jshell          | arm   | [AppGatewayWAFACLCVE202144228.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppGatewayWAFACLCVE202144228.py)                                                             |
| 109 | CKV_AZURE_138 | resource  | Microsoft.ContainerRegistry/registries                                       | Ensures that ACR disables anonymous pulling of images                                                        | arm   | [ACRAnonymousPullDisabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/ACRAnonymousPullDisabled.py)                                                                     |
| 110 | CKV_AZURE_140 | resource  | Microsoft.DocumentDB/databaseAccounts                                        | Ensure that Local Authentication is disabled on CosmosDB                                                     | arm   | [CosmosDBLocalAuthDisabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/CosmosDBLocalAuthDisabled.py)                                                                   |
| 111 | CKV_AZURE_141 | resource  | Microsoft.ContainerService/managedClusters                                   | Ensure AKS local admin account is disabled                                                                   | arm   | [AKSLocalAdminDisabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AKSLocalAdminDisabled.py)                                                                           |
| 112 | CKV_AZURE_145 | resource  | Microsoft.Web/sites                                                          | Ensure Function app is using the latest version of TLS encryption                                            | arm   | [FunctionAppMinTLSVersion.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/FunctionAppMinTLSVersion.py)                                                                     |
| 113 | CKV_AZURE_145 | resource  | Microsoft.Web/sites/slots                                                    | Ensure Function app is using the latest version of TLS encryption                                            | arm   | [FunctionAppMinTLSVersion.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/FunctionAppMinTLSVersion.py)                                                                     |
| 114 | CKV_AZURE_149 | resource  | Microsoft.Compute/virtualMachineScaleSets                                    | Ensure that Virtual machine does not enable password authentication                                          | arm   | [VMDisablePasswordAuthentication.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/VMDisablePasswordAuthentication.py)                                                       |
| 115 | CKV_AZURE_149 | resource  | Microsoft.Compute/virtualMachines                                            | Ensure that Virtual machine does not enable password authentication                                          | arm   | [VMDisablePasswordAuthentication.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/VMDisablePasswordAuthentication.py)                                                       |
| 116 | CKV_AZURE_151 | resource  | Microsoft.Compute/virtualMachines                                            | Ensure Windows VM enables encryption                                                                         | arm   | [WinVMEncryptionAtHost.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/WinVMEncryptionAtHost.py)                                                                           |
| 117 | CKV_AZURE_158 | resource  | Microsoft.Databricks/workspaces                                              | Ensure Databricks Workspace data plane to control plane communication happens over private link              | arm   | [DatabricksWorkspaceIsNotPublic.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/DatabricksWorkspaceIsNotPublic.py)                                                         |
| 118 | CKV_AZURE_160 | resource  | Microsoft.Network/networkSecurityGroups                                      | Ensure that HTTP (port 80) access is restricted from the internet                                            | arm   | [NSGRuleHTTPAccessRestricted.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/NSGRuleHTTPAccessRestricted.py)                                                               |
| 119 | CKV_AZURE_160 | resource  | Microsoft.Network/networkSecurityGroups/securityRules                        | Ensure that HTTP (port 80) access is restricted from the internet                                            | arm   | [NSGRuleHTTPAccessRestricted.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/NSGRuleHTTPAccessRestricted.py)                                                               |
| 120 | CKV_AZURE_163 | resource  | Microsoft.ContainerRegistry/registries                                       | Enable vulnerability scanning for container images.                                                          | arm   | [ACRContainerScanEnabled.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/ACRContainerScanEnabled.py)                                                                       |
| 121 | CKV_AZURE_189 | resource  | Microsoft.KeyVault/vaults                                                    | Ensure that Azure Key Vault disables public network access                                                   | arm   | [KeyVaultDisablesPublicNetworkAccess.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/KeyVaultDisablesPublicNetworkAccess.py)                                               |
| 122 | CKV_AZURE_216 | resource  | Microsoft.Network/azureFirewalls                                             | Ensure DenyIntelMode is set to Deny for Azure Firewalls                                                      | arm   | [AzureFirewallDenyThreatIntelMode.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AzureFirewallDenyThreatIntelMode.py)                                                     |
| 123 | CKV_AZURE_218 | resource  | Microsoft.Network/applicationGateways                                        | Ensure Application Gateway defines secure protocols for in transit communication                             | arm   | [AppGWDefinesSecureProtocols.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AppGWDefinesSecureProtocols.py)                                                               |
| 124 | CKV_AZURE_236 | resource  | Microsoft.CognitiveServices/accounts                                         | Ensure that Cognitive Services accounts enable local authentication                                          | arm   | [CognitiveServicesEnableLocalAuth.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/CognitiveServicesEnableLocalAuth.py)                                                     |
| 125 | CKV_AZURE_238 | resource  | Microsoft.CognitiveServices/accounts                                         | Ensure that Cognitive Services account is not configured with managed identity                               | arm   | [CognitiveServicesConfigureIdentity.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/CognitiveServicesConfigureIdentity.py)                                                 |
| 126 | CKV_AZURE_239 | resource  | Microsoft.MachineLearningServices/workspaces                                 | Ensure Azure Machine learning workspace is not configured with private endpoint                              | arm   | [AzureMLWorkspacePrivateEndpoint.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/AzureMLWorkspacePrivateEndpoint.py)                                                       |
| 127 | CKV2_AZURE_23 | resource  | Microsoft.AppPlatform/Spring                                                 | Ensure Azure spring cloud is configured with Virtual network (Vnet)                                          | arm   | [AzureSpringCloudConfigWithVnet.yaml](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/graph_checks/AzureSpringCloudConfigWithVnet.yaml)                                                 |
| 128 | CKV2_AZURE_27 | resource  | Microsoft.Sql/servers                                                        | Ensure Azure AD authentication is enabled for Azure SQL (MSSQL)                                              | arm   | [SQLServerUsesADAuth.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/SQLServerUsesADAuth.py)                                                                               |
| 129 | CKV2_AZURE_48 | resource  | Microsoft.Databricks/workspaces                                              | Ensure that Databricks Workspaces enables customer-managed key for root DBFS encryption                      | arm   | [DatabricksWorkspaceDBFSRootEncryptedWithCustomerManagedKey.py](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/resource/DatabricksWorkspaceDBFSRootEncryptedWithCustomerManagedKey.py) |
| 130 | CKV2_AZURE_49 | resource  | Microsoft.MachineLearningServices/workspaces                                 | Ensure that Azure Machine learning workspace is not configured with overly permissive network access         | arm   | [AzureMLWorkspacePublicNetwork.yaml](https://github.com/bridgecrewio/checkov/blob/main/checkov/arm/checks/graph_checks/AzureMLWorkspacePublicNetwork.yaml)                                                   |


---


